﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Telerik.XamarinForms.Input;
using Xamarin.Forms;

namespace DarkThemeTest
{
    public partial class MainPage : ContentPage
    {
        private Color _themeColor;
        private Color _fontLightColor;
        private Color _lightAccentColor;
        private Color _darkAccentColor;
        private Color _accentColor;
        private Color _veryLightAccentColor;

        private Thickness _borderThickness;

        private double _fontVerySmall;
        public MainPage()
        {
            InitializeComponent();
            //InitializeStyles();
            //this.calendar.SetStyleForCell = SetStyleForCell;
        }

        private void InitializeStyles()
        {
            _themeColor = Color.Green; // any color could be used
            _fontLightColor = Color.Red; // any color could be used
            _lightAccentColor = Color.Blue; // any color could be used
            _darkAccentColor = Color.Orange; // any color could be used
            _accentColor = Color.Gray; // any color could be used
            _veryLightAccentColor = Color.LightBlue; // any color could be used

            _borderThickness = new Thickness(1);

            _fontVerySmall = 8; // any font size could be used
        }
        
        private CalendarCellStyle SetStyleForCell(CalendarCell calendarCell)
        {
            var calendarDayCell = calendarCell as CalendarDayCell;
            var calendarTextCell = calendarCell as CalendarTextCell;

            if (calendarDayCell != null)
            {
                // CURRENT MOTH
                if (calendarDayCell.IsFromCurrentMonth)
                {
                    // Selected day style
                    if (calendarDayCell.IsSelected)
                    {
                        return new CalendarCellStyle
                        {
                            BackgroundColor = _themeColor,
                            TextColor = _fontLightColor,
                            FontSize = _fontVerySmall,
                            BorderColor = _lightAccentColor,
                            FontAttributes = calendarDayCell.IsToday ? FontAttributes.Bold : FontAttributes.None,
                            BorderThickness = _borderThickness
                        };
                    }

                    // Enabled day style for current month
                    if (calendarDayCell.IsEnabled)
                    {
                        return new CalendarCellStyle
                        {
                            BackgroundColor = _fontLightColor,
                            TextColor = _darkAccentColor,
                            FontSize = _fontVerySmall,
                            BorderColor = _lightAccentColor,
                            FontAttributes = calendarDayCell.IsToday ? FontAttributes.Bold : FontAttributes.None,
                            BorderThickness = _borderThickness
                        };
                    }

                    // Disabled day style for current month
                    return new CalendarCellStyle
                    {
                        BackgroundColor = _fontLightColor,
                        TextColor = _accentColor,
                        FontSize = _fontVerySmall,
                        BorderColor = _lightAccentColor,
                        FontAttributes = calendarDayCell.IsToday ? FontAttributes.Bold : FontAttributes.None,
                        BorderThickness = _borderThickness
                    };
                }
                // PREVIOUS/NEXT MONTH
                else
                {
                    return new CalendarCellStyle
                    {
                        BackgroundColor = _veryLightAccentColor,
                        TextColor = _accentColor,
                        FontSize = _fontVerySmall,
                        BorderColor = _lightAccentColor,
                        FontAttributes = calendarDayCell.IsToday ? FontAttributes.Bold : FontAttributes.None,
                        BorderThickness = _borderThickness
                    };
                }
            }

            if (calendarTextCell != null)
            {
                return new CalendarCellStyle
                {
                    BackgroundColor = _fontLightColor,
                    TextColor = _accentColor,
                    FontSize = _fontVerySmall,
                    BorderColor = _lightAccentColor,
                    FontAttributes = FontAttributes.None,
                    BorderThickness = _borderThickness
                };
            }

            return new CalendarCellStyle
            {
                BackgroundColor = _fontLightColor,
                TextColor = _accentColor,
                FontSize = _fontVerySmall,
                BorderColor = _lightAccentColor,
                FontAttributes = FontAttributes.None,
                BorderThickness = _borderThickness
            };
        }
    }
}
